package net.kokozo.android.nfc.torucatest;

import java.io.IOException;
import java.io.InputStream;

import android.app.Activity;
import android.content.Intent;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.NfcF;
import android.os.Bundle;
import android.view.Window;

public class torucatest extends Activity {

    private final byte push_command = (byte) 0xb0;
    private final byte activate2_command = (byte) 0xa4;
    private final int TORUCA_MAX_BYTE = 192;
    private final String TORUCA_SNIP_FILENAME = "torucatest.trp";

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);

    	Intent intent = getIntent();
    	Tag tag = (Tag) intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
    	NfcF techF = NfcF.get(tag);
    	byte[] idm = intent.getByteArrayExtra(NfcAdapter.EXTRA_ID);
        
    	byte[] iBuffer = new byte[TORUCA_MAX_BYTE];
    	byte[] torucaData = new byte[TORUCA_MAX_BYTE];
    	int torucaDataIndex = -1;
    	int size = 0;

    	try {
        	InputStream stream = getAssets().open(TORUCA_SNIP_FILENAME);
        	while ((size = stream.read(iBuffer)) > 0) {
        		for(int i = 0; i < size; i++) {
        			torucaDataIndex++;
        			torucaData[torucaDataIndex] = iBuffer[i];
        		}
        	}
        	stream.close();
        } catch (IOException e) {
        	
        }
    	int torucaDataLength = torucaDataIndex + 1;
    	
    	byte[] command = new byte[11 + torucaDataLength];
    	command[0] = (byte)(11 + torucaDataLength);
    	command[1] = push_command;
    	for(int i = 0; i < idm.length; i++) {
        	command[i+2] = idm[i];
    	}
    	command[10] = (byte) torucaDataLength;
    	for(int i = 0; i < torucaDataLength; i++) {
        	command[i+11] = torucaData[i];
    	}

    	// 902iSȑŐ@ɃgJ𑗂ꍇ́Aactivate2R}hKv܂
    	byte[] command2 = new byte[11];
    	command2[0] = (byte) 0x0b;
    	command2[1] = activate2_command;
    	for(int i = 0; i < idm.length; i++) {
        	command2[i+2] = idm[i];
    	}
    	command2[10] = (byte) 0x00;
    	
    	try {
    		techF.connect();
    		if(techF.isConnected()) {
        		techF.transceive(command);
        		techF.transceive(command2);
    		}
    		techF.close();
    	} catch (IOException e) {
    	} catch (Exception e) {
    	}

		System.exit(RESULT_OK);
    }
}
